#ifndef __X10_LANG_SYSTEM_H
#define __X10_LANG_SYSTEM_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
namespace x10 { namespace lang { 
class Long;
} } 
namespace x10 { namespace util { 
class Timer;
} } 
namespace x10 { namespace lang { 
class Int;
} } 
namespace x10 { namespace compiler { 
class Native;
} } 
namespace x10 { namespace lang { 
class Runtime;
} } 
namespace x10 { namespace lang { 
class Place;
} } 
namespace x10 { namespace util { 
template<class TPMGL(K), class TPMGL(V)> class Map;
} } 
namespace x10 { namespace lang { 
class String;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace lang { 
class Thread;
} } 
namespace x10 { namespace lang { 
class InterruptedException;
} } 
namespace x10 { namespace lang { 

class System : public x10::lang::Object   {
    public:
    RTT_H_DECLS_CLASS
    
    void _constructor();
    
    static x10aux::ref<x10::lang::System> _make();
    
    static x10_long currentTimeMillis();
    static x10_long nanoTime();
    static void exit();
    static void setExitCode(x10_int exitCode);
    static x10aux::ref<x10::util::Map<x10aux::ref<x10::lang::String>, x10aux::ref<x10::lang::String> > >
      getenv();
    static x10_boolean sleep(x10_long millis);
    virtual x10aux::ref<x10::lang::System> x10__lang__System____x10__lang__System__this(
      );
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_LANG_SYSTEM_H

namespace x10 { namespace lang { 
class System;
} } 

#ifndef X10_LANG_SYSTEM_H_NODEPS
#define X10_LANG_SYSTEM_H_NODEPS
#ifndef X10_LANG_SYSTEM_H_GENERICS
#define X10_LANG_SYSTEM_H_GENERICS
#endif // X10_LANG_SYSTEM_H_GENERICS
#endif // __X10_LANG_SYSTEM_H_NODEPS
